<script lang="ts">
	import '$lib/styles/app.css';
	import anime from 'animejs';
	import { fade, fly } from 'svelte/transition';

	let img: HTMLImageElement;
	let modal: HTMLDivElement;
	let modalContent: HTMLDivElement;
	let btn: HTMLButtonElement;

	let showModal = false;
	let textHidden = false;
	let startAnimation = false;
	let hiddenBtn = false;

	let beforeStartshowModal = 0;
	const duration = 1.2;
	function animationGift() {
		if (img && !showModal && !startAnimation) {
			startAnimation = true;
			hiddenBtn = true;
			beforeStartshowModal = modal.offsetHeight;
			anime({
				targets: img,
				rotate: '-10',
				easing: 'linear',
				duration: 75 * duration,
				direction: 'alternate',
				complete() {
					anime({
						targets: img,
						rotate: '10',
						easing: 'linear',
						duration: 75 * duration,
						complete() {
							anime({
								targets: img,
								rotate: '0',
								easing: 'linear',
								duration: 75 * duration,
								complete() {
									anime({
										targets: img,
										height: '53px',
										width: '230px',
										easing: 'linear',
										duration: 75 * duration,
										complete() {
											modal.style.position = 'fixed';
											anime({
												targets: modal,
												height: '100vh',
												backgroundColor: 'rgba(0,0,0,70%)',
												backdropFilter: 'blur(10px)',
												easing: 'linear',
												duration: 100 * duration,
												begin() {
													textHidden = true;
												},
												complete: () => {
													showModal = true;
													anime({
														targets: modalContent,
														height: '420px',
														width: '350px',
														background: "url('/gift-bg.svg')",
														easing: 'linear',
														duration: 300 * duration
													});
												}
											});
											anime({
												targets: img,
												translateY: -55,
												height: '106px',
												width: '120px',
												easing: 'linear',
												duration: 50 * duration,
												complete: () => {
													startAnimation = false;
												}
											});
										}
									});
								}
							});
						}
					});
				}
			});
		}
	}

	function closeModal() {
		if (showModal) {
			anime({
				targets: modal,
				backgroundColor: 'rgba(0,0,0,0%)',
				easing: 'linear',
				duration: 100 * duration,
				complete: () => {
					anime({
						targets: modal,
						height: beforeStartshowModal + 'px',
						easing: 'linear',
						duration: 100 * duration,
						complete: () => {
							showModal = false;
							anime({
								targets: modalContent,
								height: '420px',
								width: '100%',
								background: 'rgba(0,0,0,0%)',
								easing: 'linear',
								duration: 150,
								complete() {
									anime({
										targets: img,
										translateY: 0,
										height: '106px',
										width: '120px',
										easing: 'linear',
										duration: 150,
										complete() {
											modalContent.removeAttribute('style');
											modal.removeAttribute('style');
											img.removeAttribute('style');
											textHidden = false;
											hiddenBtn = false;
										}
									});
								}
							});
						}
					});
				}
			});
		}
	}
</script>

<div
	class="tw-flex tw-items-center tw-flex-col tw-justify-center tw-w-full tw-transition-all"
	bind:this={modal}
	on:click={closeModal}
>
	<div
		bind:this={modalContent}
		class="tw-bg-cover tw-bg-center tw-relative !tw-min-h-[202px]"
		on:click|stopPropagation
	>
		<div class="tw-flex tw-items-center tw-justify-center tw-flex-col tw-gap-y-12">
			<div
				class="tw-flex tw-items-center tw-justify-center tw-gap-x-2.5 tw-text-4xl tw-font-bold tw-uppercase"
				in:fly={{ y: 200, duration: 300 }}
			>
				{#if !textHidden}
					<span
						out:fade={{
							duration: 50
						}}
						in:fly={{ x: -200, duration: 100 }}
						class="tw-bg-gradient-to-b tw-from-[#FCE361] tw-to-[#E63801] tw-bg-clip-text tw-text-transparent"
					>
						you
					</span>
				{/if}
				<img bind:this={img} src="/gift.png" alt="" />
				{#if !textHidden}
					<span
						in:fly={{ x: 200, duration: 100 }}
						out:fade={{
							duration: 50
						}}
						class="tw-bg-gradient-to-b tw-from-[#FCE361] tw-to-[#E63801] tw-bg-clip-text tw-text-transparent"
					>
						win
					</span>
				{/if}
			</div>
			{#if !hiddenBtn}<button
					bind:this={btn}
					transition:fade={{
						duration: 100
					}}
					class={`tw-bg-[url('/btn-bg.svg')] tw-bg-contain tw-bg-center tw-bg-no-repeat tw-py-3 tw-px-14 ${
						startAnimation ? '!tw-opacity-0' : '!tw-opacity-100'
					}`}
					on:click={animationGift}
				>
					<span
						class="tw-bg-gradient-to-b tw-from-[#FCE361] tw-to-[#E63801] tw-bg-clip-text tw-text-transparent tw-text-base tw-font-bold"
						>Open Gift</span
					>
				</button>
			{/if}
		</div>
		{#if showModal}
			<div class="tw-flex tw-flex-col tw-items-center tw-justify-center tw-gap-x-[56px]">
				<img src="/bonus-img.svg" alt="" />
				<button
					class="tw-bg-[url('/btn-bg.svg')] tw-bg-contain tw-bg-center tw-bg-no-repeat tw-py-3 tw-px-14"
				>
					<span
						class="tw-bg-gradient-to-b tw-from-[#FCE361] tw-to-[#E63801] tw-bg-clip-text tw-text-transparent tw-text-base tw-font-bold"
						>Continue</span
					>
				</button>
			</div>
		{/if}
	</div>
</div>
